/*$Id: acre_print_dense_matrix_serial.c 1.1 2004/04/30 J. Malard Exp d3j540$*/

#include <stdlib.h>
#include <assert.h>
#include "tao.h"
#include "acre.h"
#include "petscmat.h" 
#include "copyright.h"
#undef __FUNC__
#define __FUNC__ "acre_print_dense_matrix_serial"
int acre_print_dense_matrix_serial(Mat A, char * infile, PetscTruth format)
{
	int ierr;
	PetscViewer fd;

	HELLO("acre_print_dense_matrix_serial enter");

	if ( format==PETSC_TRUE )
	{
		int i, j;
		int m, n;
		Vec aVec;

		ierr = MatGetSize( A, &m, &n);			CHKERRQ(ierr);

		ierr = VecCreateMPI( PETSC_COMM_WORLD,
			PETSC_DECIDE, m, &aVec);		CHKERRQ(ierr);

		ierr = PetscViewerASCIIOpen(PETSC_COMM_WORLD,
			infile, &fd);				CHKERRQ(ierr);
		PetscViewerASCIIPrintf(fd,"%d\t%d\n",m,n);
		for ( j=0; j<n; j++ )
		{
			PetscScalar *vals;

			ierr = MatGetColumnVector(A, aVec, j);	CHKERRQ(ierr);

			ierr = VecGetArray( aVec, &vals);	CHKERRQ(ierr);
			for ( i=0; i<m; i++ )
			{
				PetscViewerASCIIPrintf(fd,
					"\t%lg", vals[i]);
			}
			PetscViewerASCIIPrintf(fd, "\n");
			ierr = VecRestoreArray( aVec, &vals);	CHKERRQ(ierr);
		}
		ierr = PetscViewerDestroy(fd);			CHKERRQ(ierr);
		ierr = VecDestroy(aVec);			CHKERRQ(ierr);
	}
	else
	{
		ierr = PetscViewerBinaryOpen(PETSC_COMM_SELF,
			infile, PETSC_FILE_CREATE,&fd);		CHKERRQ(ierr);
		ierr = MatView(A,fd);				CHKERRQ(ierr);
		ierr = PetscViewerDestroy(fd);			CHKERRQ(ierr);
	}
	
	HELLO("acre_print_dense_matrix_serial exit");

	return ierr;
}
