/*$Id: acre_write_tao_solver_state.c,v 1.1 2004/04/30 J. Malard Exp d3j540 $ */

#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include "tao.h"
#include "acre.h"
#include "copyright.h"
#undef __FUNC__  
#define __FUNC__ "acre_write_tao_solver_state"
int acre_write_tao_solver_state(TAO_SOLVER reml)
{
	int ierr;
	int nits;
	int here;
	TaoTerminateReason reason;

	HELLO("acre_write_tao_solver_state enter");

	ierr = MPI_Comm_rank(MPI_COMM_WORLD,&here);
		assert(ierr==MPI_SUCCESS);

	if ( here==0 )
	{
		double objf, gn, cn, dx;

		ierr = TaoView(reml);				CHKERRQ(ierr);

		ierr = TaoGetSolutionStatus( reml,
			&nits, &objf, &gn, &cn, &dx, &reason);	CHKERRQ(ierr);

		PetscPrintf(PETSC_COMM_SELF,
			"%s = %d\n", "number of iterations",
			nits);

		PetscPrintf(PETSC_COMM_SELF,
			"%s = %lg\n", "Likelihood", objf);
	
		PetscPrintf(PETSC_COMM_SELF,
			"%s = %lg\n", "Gradient norm", gn);
	
		PetscPrintf(PETSC_COMM_SELF,
			"%s = %lg\n", "Infeasibility norm", cn);
	
		PetscPrintf(PETSC_COMM_SELF,
			"%s = %lg\n", "Final displacement", dx);
	
		PetscPrintf(PETSC_COMM_SELF,
			"Convergence: %s\n",
			(reason==TAO_CONVERGED_ATOL) ?
				"TAO_CONVERGED_ATOL" :
			(reason==TAO_CONVERGED_RTOL) ?
				"TAO_CONVERGED_RTOL" :
			(reason==TAO_CONVERGED_TRTOL) ?
				"TAO_CONVERGED_TRTOL" :
			(reason==TAO_CONVERGED_MINF) ?
				"TAO_CONVERGED_MINF" :
			(reason==TAO_DIVERGED_MAXITS) ?
				"TAO_DIVERGED_MAXITS" :
			(reason==TAO_DIVERGED_NAN) ?
				"TAO_DIVERGED_NAN" :
			(reason==TAO_DIVERGED_MAXFCN) ?
				"TAO_DIVERGED_MAXFCN" :
			(reason==TAO_DIVERGED_LS_FAILURE) ?
				"TAO_DIVERGED_LS_FAILURE" :
			(reason==TAO_DIVERGED_TR_REDUCTION) ?
				"TAO_DIVERGED_TR_REDUCTION" :
			"Don't know");
	
		PetscSynchronizedPrintf( PETSC_COMM_SELF,
			"%s%s%s%s\n",
			"********************",
			"********************",
			"********************",
			"************");
	}

	HELLO("acre_write_tao_solver_state exit");

	return 0;

}

